import {Action} from 'redux'

export interface ActionBase extends Action {
  readonly type: ActionType
}

export enum ActionType {
  GET_systemSettings = 'systemSettingsReducer_GET_systemSettings',
  GET_systemSettings_PENDING = 'systemSettingsReducer_GET_systemSettings_PENDING',
  GET_systemSettings_FULFILLED = 'systemSettingsReducer_GET_systemSettings_FULFILLED',
  GET_systemSettings_REJECTED = 'systemSettingsReducer_GET_systemSettings_REJECTED',

  GET_initialSystemSettings = 'systemSettingsReducer_GET_initialSystemSettings',
  GET_initialSystemSettings_PENDING = 'systemSettingsReducer_GET_initialSystemSettings_PENDING',
  GET_initialSystemSettings_FULFILLED = 'systemSettingsReducer_GET_initialSystemSettings_FULFILLED',
  GET_initialSystemSettings_REJECTED = 'systemSettingsReducer_GET_initialSystemSettings_REJECTED',

  UPDATE_systemSettings = 'systemSettingsReducer_UPDATE_systemSettings',
  UPDATE_systemSettings_PENDING = 'systemSettingsReducer_UPDATE_systemSettings_PENDING',
  UPDATE_systemSettings_FULFILLED = 'systemSettingsReducer_UPDATE_systemSettings_FULFILLED',
  UPDATE_systemSettings_REJECTED = 'systemSettingsReducer_UPDATE_systemSettings_REJECTED',

  GET_allDefaultRoles = 'systemSettingsReducer_GET_allDefaultRoles',
  GET_allDefaultRoles_PENDING = 'systemSettingsReducer_GET_allDefaultRoles_PENDING',
  GET_allDefaultRoles_FULFILLED = 'systemSettingsReducer_GET_allDefaultRoles_FULFILLED',
  GET_allDefaultRoles_REJECTED = 'systemSettingsReducer_GET_allDefaultRoles_REJECTED',

  GET_allDefaultGroups = 'systemSettingsReducerGET_allDefaultGroups',
  GET_allDefaultGroups_PENDING = 'systemSettingsReducerGET_allDefaultGroups_PENDING',
  GET_allDefaultGroups_FULFILLED = 'systemSettingsReducerGET_allDefaultGroups_FULFILLED',
  GET_allDefaultGroups_REJECTED = 'systemSettingsReducerGET_allDefaultGroups_REJECTED',

  SET_serverMessage = 'systemSettingsReducer_SET_serverMessage',


  SET_maxCustomProjectsPerUser = 'systemSettingsReducer_SET_maxCustomProjectsPerUser',
  SET_maxCustomTestsPerParticipation = 'systemSettingsReducer_SET_maxCustomTestsPerParticipation',
  SET_testServerUrl = 'systemSettingsReducer_SET_testServerUrl',
  SET_testServerStatsUrl = 'systemSettingsReducer_SET_testServerStatsUrl',
  SET_submitTestServerUrl = 'systemSettingsReducer_SET_submitTestServerUrl',

  SET_testServerConfigUiUrl = 'systemSettingsReducer_SET_testServerConfigUiUrl',

  SET_testServerTimeoutInMs = 'systemSettingsReducer_SET_testServerTimeoutInMs',
  SET_submitTestServerTimeoutInMs = 'systemSettingsReducer_SET_submitTestServerTimeoutInMs',
  SET_maxNumberOfTestsWithOneRequest = 'systemSettingsReducer_SET_maxNumberOfTestsWithOneRequest',
  SET_maxNumberOfTestsWithOneRequestSubmitTestServer = 'systemSettingsReducer_SET_maxNumberOfTestsWithOneRequestSubmitTestServer',

  SET_justRunProgramTimeoutInMs = 'systemSettingsReducer_SET_justRunProgramTimeoutInMs',
  SET_justRunProgramCompileTimeoutInMs = 'systemSettingsReducer_SET_justRunProgramCompileTimeoutInMs',
  SET_justRunProgramMemoryLimitInKb = 'systemSettingsReducer_SET_justRunProgramMemoryLimitInKb',
  SET_justRunProgramMaxDiskSpaceInKb = 'systemSettingsReducer_SET_justRunProgramMaxDiskSpaceInKb',

  SET_customProjectTestTimeoutInMs = 'systemSettingsReducer_SET_customProjectTestTimeoutInMs',
  SET_customProjectTestCompileTimeoutInMs = 'systemSettingsReducer_SET_customProjectTestCompileTimeoutInMs',
  SET_customProjectTestMemoryLimitInKb = 'systemSettingsReducer_SET_customProjectTestMemoryLimitInKb',
  SET_customProjectTestMaxDiskSpaceInKb = 'systemSettingsReducer_SET_customProjectTestMaxDiskSpaceInKb',

  SET_defaultUserGroupId = 'systemSettingsReducer_SET_defaultUserGroupId',
  SET_defaultGroupRoleId = 'systemSettingsReducer_SET_defaultGroupRoleId',
  SET_defaultGroupCreatorGroupRoleId = 'systemSettingsReducer_SET_defaultGroupCreatorGroupRoleId',

  RESET = 'systemSettingsReducer_RESET',
}
